  MEMBER
  INCLUDE('MyFile.inc'),ONCE

MyFileManager.Fetch PROCEDURE(KEY K,? F1,<? F2>,<? F3>,<? F4>,<? F5>,<? F6>,<? F7>,<? F8>,<? F9>)
  CODE
  IF SELF.AssignKeyFields(K,F1,F2,F3,F4,F5,F6,F7,F8,F9) <> K{PROP:Components}
    SELF.SetKey(K)
    MESSAGE('Too few components for MyFileManager.Fetch|' |
            & SELF.GetName(), 'Programmer Error!', ICON:Hand)
    HALT(0)
  END!IF
  RETURN PARENT.Fetch(K)

MyFileManager.TryFetch PROCEDURE(KEY K,? F1,<? F2>,<? F3>,<? F4>,<? F5>,<? F6>,<? F7>,<? F8>,<? F9>)
  CODE
  IF SELF.AssignKeyFields(K,F1,F2,F3,F4,F5,F6,F7,F8,F9) <> K{PROP:Components}
    SELF.SetKey(K)  !Prepare internal queue to get Description
    MESSAGE('Too few components for MyFileManager.TryFetch|' |
            & SELF.GetName(), 'Programmer Error!', ICON:Hand)
    HALT(0)
  END!IF
  RETURN PARENT.TryFetch(K)

MyFileManager.AssignKeyFields PROCEDURE(KEY K,<? F1>,<? F2>,<? F3>,<? F4>,<? F5>,<? F6>,<? F7>,<? F8>,<? F9>)
C BYTE,AUTO
N BYTE(0)
X BYTE,AUTO
F ANY                ! Field reference for value assignment
  CODE
  C = K{PROP:Components}
  LOOP X = 9 TO 1 BY -1
    IF OMITTED(2+X)  ! 1 for the class, and 1 for the key
      IF N           ! If count already remembered
        N = 0        ! Middle omits forbidden!
      END!IF
    ELSE
      IF N = 0       ! Haven't found last yet?
        N = X        ! This is the last
      END!IF
      IF X =< C      ! Within key's components?
        F &= WHAT(SELF.Buffer, K{PROP:Field,X})
        EXECUTE X
          F=F1; F=F2; F=F3; F=F4; F=F5; F=F6; F=F7; F=F8; F=F9
        END!EXECUTE
      END!IF
    END!IF
  END!LOOP
  RETURN N
